Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Java™ Platform Standard Ed. 6
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.annotation.processing
Interface ProcessingEnvironment

    public interface ProcessingEnvironment

An annotation processing tool framework will provide an annotation processor with an object implementing this interface so the processor can use facilities provided by the framework to write new files, report error messages, and find other utilities.

Third parties may wish to provide value-add wrappers around the facility objects from this interface, for example a `Filer` extension that allows multiple processors to coordinate writing out a single source file. To enable this, for processors running in a context where their side effects via the API could be visible to each other, the tool infrastructure must provide corresponding facility objects that are `.equals`, `Filer`s that are `.equals`, and so on. In addition, the tool invocation must be able to be configured such that from the perspective of the running annotation processors, at least the chosen subset of helper classes are viewed as being loaded by the same class loader. (Since the facility objects manage shared state, the implementation of a wrapper class must know whether or not the same base facility object has been wrapped before.)

Since:
  1.6

Method Summary
`Elements` | `getElementUtils()` Returns an implementation of some utility methods for operating on elements
`Filer` | `getFiler()` Returns the filer used to create new source, class, or auxiliary files.
`Locale` | `getLocale()` Returns the current locale or `null` if no locale is in effect.
`Messager` | `getMessager()` Returns the messager used to report errors, warnings, and other notices.
`Map<String,String>` | `getOptions()` Returns the processor-specific options passed to the annotation processing tool.
`SourceVersion` | `getSourceVersion()` Returns the source version that any generated source and class files should conform to.
`Types` | `getTypeUtils()` Returns an implementation of some utility methods for operating on types.

Method Detail

### getOptions

    Map<String,String> getOptions()

  Returns the processor-specific options passed to the annotation processing tool. Options are returned in the form of a map from option name to option value. For an option with no value, the corresponding value in the map is `null`.

  See documentation of the particular tool infrastructure being used for details on how to pass in processor-specific options. For example, a command-line implementation may distinguish processor-specific options by prefixing them with a known string like `"-A"`; other tool implementations may follow different conventions or provide alternative mechanisms. A given implementation may also provide implementation-specific ways of finding options passed to the tool in addition to the processor-specific options.

  Returns:
    the processor-specific options passed to the tool

### getMessager

    Messager getMessager()

  Returns the messager used to report errors, warnings, and other notices.

  Returns:
    the messager

### getFiler

    Filer getFiler()

  Returns the filer used to create new source, class, or auxiliary files.

  Returns:
    the filer

### getElementUtils

    Elements getElementUtils()

  Returns an implementation of some utility methods for operating on elements

  Returns:
    element utilities

### getTypeUtils

    Types getTypeUtils()

  Returns an implementation of some utility methods for operating on types.

  Returns:
    type utilities

### getSourceVersion

    SourceVersion getSourceVersion()

  Returns the source version that any generated source and class files should conform to.

  Returns:
    the source version to which generated source and class files should conform to
  See Also:
    `Processor.getSupportedSourceVersion()`

### getLocale

    Locale getLocale()

  Returns the current locale or `null` if no locale is in effect. The locale can be be used to provide localized messages.

  Returns:
    the current locale or `null` if no locale is in effect

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Java™ Platform Standard Ed. 6
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2009 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.